searchData={"items":[{"type":"task","title":"mix tz_world.update","doc":"Downloads and installs the latest Timezone GeoJSON data.","ref":"Mix.Tasks.TzWorld.Update.html"},{"type":"task","title":"Argument - mix tz_world.update","doc":"* `--include-oceans` Will include the geojson for\n  oceans in the downloaded data.\n\n* `--force` will force an update even if the data is\n  current. This can be used to force downloading data\n  including (or not including) time zone data for the oceans.","ref":"Mix.Tasks.TzWorld.Update.html#module-argument"},{"type":"function","title":"Mix.Tasks.TzWorld.Update.run/1","doc":"","ref":"Mix.Tasks.TzWorld.Update.html#run/1"},{"type":"function","title":"Mix.Tasks.TzWorld.Update.update/3","doc":"","ref":"Mix.Tasks.TzWorld.Update.html#update/3"},{"type":"module","title":"TzWorld","doc":"Resolve a timezone name from coordinates.","ref":"TzWorld.html"},{"type":"function","title":"TzWorld.all_timezones_at/2","doc":"Returns all timezone name found for the given\ncoordinates specified as either a `Geo.Point`,\na `Geo.PointZ` or a tuple `{lng, lat}`","ref":"TzWorld.html#all_timezones_at/2"},{"type":"function","title":"Arguments - TzWorld.all_timezones_at/2","doc":"* `point` is a `Geo.Point.t()` a `Geo.PointZ.t()` or\n  a tuple `{lng, lat}`\n\n* `backend` is any backend access module.","ref":"TzWorld.html#all_timezones_at/2-arguments"},{"type":"function","title":"Returns - TzWorld.all_timezones_at/2","doc":"* `{:ok, timezone}` or\n\n* `{:error, :time_zone_not_found}`","ref":"TzWorld.html#all_timezones_at/2-returns"},{"type":"function","title":"Notes - TzWorld.all_timezones_at/2","doc":"Note that the point is always expressed as\n`lng` followed by `lat`.","ref":"TzWorld.html#all_timezones_at/2-notes"},{"type":"function","title":"Examples - TzWorld.all_timezones_at/2","doc":"iex> TzWorld.all_timezones_at(%Geo.Point{coordinates: {3.2, 45.32}})\n    {:ok, [\"Europe/Paris\"]}\n\n    iex> TzWorld.all_timezones_at({3.2, 45.32})\n    {:ok, [\"Europe/Paris\"]}\n\n    iex> TzWorld.all_timezones_at({0.0, 0.0})\n    {:ok, []}\n\n\nThe algorithm starts by filtering out timezones whose bounding\nbox does not contain the given point.\n\nOnce filtered, all timezones which contains the given\npoint is returned, or an error tuple if none of the\ntimezones match.\n\nIn rare cases, typically due to territorial disputes,\none or more timezones may apply to a given location.\nThis function returns all time zones that match.","ref":"TzWorld.html#all_timezones_at/2-examples"},{"type":"function","title":"TzWorld.app_name/0","doc":"Returns the OTP app name of :tz_world","ref":"TzWorld.html#app_name/0"},{"type":"function","title":"TzWorld.fetch_backend/0","doc":"","ref":"TzWorld.html#fetch_backend/0"},{"type":"function","title":"TzWorld.reload_timezone_data/0","doc":"Reload the timezone geometry data.\n\nThis allows for the data to be reloaded,\ntypically with a new release, without\nrestarting the application.","ref":"TzWorld.html#reload_timezone_data/0"},{"type":"function","title":"TzWorld.timezone_at/2","doc":"Returns the *first* timezone name found for the given\ncoordinates specified as either a `Geo.Point`,\na `Geo.PointZ` or a tuple `{lng, lat}`","ref":"TzWorld.html#timezone_at/2"},{"type":"function","title":"Arguments - TzWorld.timezone_at/2","doc":"* `point` is a `Geo.Point.t()` a `Geo.PointZ.t()` or\n  a tuple `{lng, lat}`\n\n* `backend` is any backend access module.","ref":"TzWorld.html#timezone_at/2-arguments"},{"type":"function","title":"Returns - TzWorld.timezone_at/2","doc":"* `{:ok, timezone}` or\n\n* `{:error, :time_zone_not_found}`","ref":"TzWorld.html#timezone_at/2-returns"},{"type":"function","title":"Notes - TzWorld.timezone_at/2","doc":"Note that the point is always expressed as\n`lng` followed by `lat`.","ref":"TzWorld.html#timezone_at/2-notes"},{"type":"function","title":"Examples - TzWorld.timezone_at/2","doc":"iex> TzWorld.timezone_at(%Geo.Point{coordinates: {3.2, 45.32}})\n    {:ok, \"Europe/Paris\"}\n\n    iex> TzWorld.timezone_at({3.2, 45.32})\n    {:ok, \"Europe/Paris\"}\n\n    iex> TzWorld.timezone_at({0.0, 0.0})\n    {:error, :time_zone_not_found}\n\n\nThe algorithm starts by filtering out timezones whose bounding\nbox does not contain the given point.\n\nOnce filtered, the *first* timezone which contains the given\npoint is returned, or an error tuple if none of the\ntimezones match.\n\nIn rare cases, typically due to territorial disputes,\none or more timezones may apply to a given location.\nThis function returns the first time zone that matches.","ref":"TzWorld.html#timezone_at/2-examples"},{"type":"function","title":"TzWorld.version/0","doc":"Returns the installed version of time\nzone data","ref":"TzWorld.html#version/0"},{"type":"function","title":"Example - TzWorld.version/0","doc":"TzWorld.version\n    => {:ok, \"2020d\"}","ref":"TzWorld.html#version/0-example"},{"type":"type","title":"TzWorld.backend/0","doc":"","ref":"TzWorld.html#t:backend/0"},{"type":"behaviour","title":"TzWorld.Backend","doc":"Defines the callbacks for the TzWorld.Backend\nbehaviour","ref":"TzWorld.Backend.html"},{"type":"callback","title":"TzWorld.Backend.all_timezones_at/1","doc":"Returns all timezones at a specified point","ref":"TzWorld.Backend.html#c:all_timezones_at/1"},{"type":"callback","title":"TzWorld.Backend.reload_timezone_data/0","doc":"Reloads the (potentially updated) timezone data","ref":"TzWorld.Backend.html#c:reload_timezone_data/0"},{"type":"callback","title":"TzWorld.Backend.timezone_at/1","doc":"Returns the time zone at a specified point","ref":"TzWorld.Backend.html#c:timezone_at/1"},{"type":"type","title":"TzWorld.Backend.geo/0","doc":"A point","ref":"TzWorld.Backend.html#t:geo/0"},{"type":"type","title":"TzWorld.Backend.lat/0","doc":"Latitude in degrees","ref":"TzWorld.Backend.html#t:lat/0"},{"type":"type","title":"TzWorld.Backend.lng/0","doc":"Longitude in degrees","ref":"TzWorld.Backend.html#t:lng/0"},{"type":"module","title":"TzWorld.Backend.Memory","doc":"","ref":"TzWorld.Backend.Memory.html"},{"type":"function","title":"TzWorld.Backend.Memory.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"TzWorld.Backend.Memory.html#child_spec/1"},{"type":"module","title":"TzWorld.Downloader","doc":"Function to support downloading the latest\ntimezones geo JSON data","ref":"TzWorld.Downloader.html"},{"type":"function","title":"TzWorld.Downloader.certificate_locations/0","doc":"","ref":"TzWorld.Downloader.html#certificate_locations/0"},{"type":"function","title":"TzWorld.Downloader.current_release/0","doc":"Returns the current installed timezones geo JSON\ndata.","ref":"TzWorld.Downloader.html#current_release/0"},{"type":"function","title":"TzWorld.Downloader.get/2","doc":"Securely download https content from\na URL.\n\nThis function uses the built-in `:httpc`\nclient but enables certificate verification\nwhich is not enabled by `:httc` by default.\n\nSee also https://erlef.github.io/security-wg/secure_coding_and_deployment_hardening/ssl","ref":"TzWorld.Downloader.html#get/2"},{"type":"function","title":"Arguments - TzWorld.Downloader.get/2","doc":"* `url` is a binary URL or a `{url, list_of_headers}` tuple. If\n  provided the headers are a list of `{'header_name', 'header_value'}`\n  tuples. Note that the name and value are both charlists, not\n  strings.\n\n* `options` is a keyword list of options.","ref":"TzWorld.Downloader.html#get/2-arguments"},{"type":"function","title":"Options - TzWorld.Downloader.get/2","doc":"* `:verify_peer` is a boolean value indicating\n  if peer verification should be done for this request.\n  The default is `true` in which case the default\n  `:ssl` options follow the [erlef guidelines](https://erlef.github.io/security-wg/secure_coding_and_deployment_hardening/ssl)\n  noted above.\n\n* `:timeout` is the number of milliseconds available\n  for the request to complete. The default is\n  \"120000\". This option may also be\n  set with the `CLDR_HTTP_TIMEOUT` environment variable.\n\n* `:connection_timeout` is the number of milliseconds\n  available for the a connection to be estabklished to\n  the remote host. The default is \"60000\".\n  This option may also be set with the\n  `CLDR_HTTP_CONNECTION_TIMEOUT` environment variable.","ref":"TzWorld.Downloader.html#get/2-options"},{"type":"function","title":"Returns - TzWorld.Downloader.get/2","doc":"* `{:ok, body}` if the return is successful.\n\n* `{:not_modified, headers}` if the request would result in\n  returning the same results as one matching an etag.\n\n* `{:error, error}` if the download is\n   unsuccessful. An error will also be logged\n   in these cases.","ref":"TzWorld.Downloader.html#get/2-returns"},{"type":"function","title":"Unsafe HTTPS - TzWorld.Downloader.get/2","doc":"If the environment variable `CLDR_UNSAFE_HTTPS` is\nset to anything other than `FALSE`, `false`, `nil`\nor `NIL` then no peer verification of certificates\nis performed. Setting this variable is not recommended\nbut may be required is where peer verification for\nunidentified reasons. Please [open an issue](https://github.com/elixir-cldr/cldr/issues)\nif this occurs.","ref":"TzWorld.Downloader.html#get/2-unsafe-https"},{"type":"function","title":"Certificate stores - TzWorld.Downloader.get/2","doc":"In order to keep dependencies to a minimum,\n`get/1` attempts to locate an already installed\ncertificate store. It will try to locate a\nstore in the following order which is intended\nto satisfy most host systems. The certificate\nstore is expected to be a path name on the\nhost system.\n\n```elixir\n# A certificate store configured by the\n# developer\nApplication.get_env(:ex_cldr, :cacertfile)\n\n# Populated if hex package `CAStore` is configured\nCAStore.file_path()\n\n# Populated if hex package `certfi` is configured\n:certifi.cacertfile()\n\n# Debian/Ubuntu/Gentoo etc.\n\"/etc/ssl/certs/ca-certificates.crt\",\n\n# Fedora/RHEL 6\n\"/etc/pki/tls/certs/ca-bundle.crt\",\n\n# OpenSUSE\n\"/etc/ssl/ca-bundle.pem\",\n\n# OpenELEC\n\"/etc/pki/tls/cacert.pem\",\n\n# CentOS/RHEL 7\n\"/etc/pki/ca-trust/extracted/pem/tls-ca-bundle.pem\",\n\n# Open SSL on MacOS\n\"/usr/local/etc/openssl/cert.pem\",\n\n# MacOS & Alpine Linux\n\"/etc/ssl/cert.pem\"\n```","ref":"TzWorld.Downloader.html#get/2-certificate-stores"},{"type":"function","title":"TzWorld.Downloader.get_and_load_latest_release/3","doc":"","ref":"TzWorld.Downloader.html#get_and_load_latest_release/3"},{"type":"function","title":"TzWorld.Downloader.get_latest_release/3","doc":"","ref":"TzWorld.Downloader.html#get_latest_release/3"},{"type":"function","title":"TzWorld.Downloader.get_url/1","doc":"","ref":"TzWorld.Downloader.html#get_url/1"},{"type":"function","title":"TzWorld.Downloader.get_with_headers/2","doc":"Securely download https content from\na URL.\n\nThis function uses the built-in `:httpc`\nclient but enables certificate verification\nwhich is not enabled by `:httc` by default.\n\nSee also https://erlef.github.io/security-wg/secure_coding_and_deployment_hardening/ssl","ref":"TzWorld.Downloader.html#get_with_headers/2"},{"type":"function","title":"Arguments - TzWorld.Downloader.get_with_headers/2","doc":"* `url` is a binary URL or a `{url, list_of_headers}` tuple. If\n  provided the headers are a list of `{'header_name', 'header_value'}`\n  tuples. Note that the name and value are both charlists, not\n  strings.\n\n* `options` is a keyword list of options.","ref":"TzWorld.Downloader.html#get_with_headers/2-arguments"},{"type":"function","title":"Options - TzWorld.Downloader.get_with_headers/2","doc":"* `:verify_peer` is a boolean value indicating\n  if peer verification should be done for this request.\n  The default is `true` in which case the default\n  `:ssl` options follow the [erlef guidelines](https://erlef.github.io/security-wg/secure_coding_and_deployment_hardening/ssl)\n  noted above.\n\n* `:timeout` is the number of milliseconds available\n  for the request to complete. The default is\n  \"120000\". This option may also be\n  set with the `CLDR_HTTP_TIMEOUT` environment variable.\n\n* `:connection_timeout` is the number of milliseconds\n  available for the a connection to be estabklished to\n  the remote host. The default is \"60000\".\n  This option may also be set with the\n  `CLDR_HTTP_CONNECTION_TIMEOUT` environment variable.\n\n* `:https_proxy` is the URL of an https proxy to be used. The\n  default is `nil`.","ref":"TzWorld.Downloader.html#get_with_headers/2-options"},{"type":"function","title":"Returns - TzWorld.Downloader.get_with_headers/2","doc":"* `{:ok, body, headers}` if the return is successful.\n\n* `{:not_modified, headers}` if the request would result in\n  returning the same results as one matching an etag.\n\n* `{:error, error}` if the download is\n   unsuccessful. An error will also be logged\n   in these cases.","ref":"TzWorld.Downloader.html#get_with_headers/2-returns"},{"type":"function","title":"Unsafe HTTPS - TzWorld.Downloader.get_with_headers/2","doc":"If the environment variable `CLDR_UNSAFE_HTTPS` is\nset to anything other than `FALSE`, `false`, `nil`\nor `NIL` then no peer verification of certificates\nis performed. Setting this variable is not recommended\nbut may be required is where peer verification for\nunidentified reasons. Please [open an issue](https://github.com/elixir-cldr/cldr/issues)\nif this occurs.","ref":"TzWorld.Downloader.html#get_with_headers/2-unsafe-https"},{"type":"function","title":"Https Proxy - TzWorld.Downloader.get_with_headers/2","doc":"`Cldr.Http.get/2` will look for a proxy URL in the following\nlocales in the order presented:\n\n* `options[:https_proxy]`\n* `ex_cldr` compile-time configuration under the\n  key `:ex_cldr[:https_proxy]`\n* The environment variable `HTTPS_PROXY`\n* The environment variable `https_proxy`","ref":"TzWorld.Downloader.html#get_with_headers/2-https-proxy"},{"type":"function","title":"Certificate stores - TzWorld.Downloader.get_with_headers/2","doc":"In order to keep dependencies to a minimum,\n`get/1` attempts to locate an already installed\ncertificate store. It will try to locate a\nstore in the following order which is intended\nto satisfy most host systems. The certificate\nstore is expected to be a path name on the\nhost system.\n\n```elixir\n# A certificate store configured by the\n# developer\nApplication.get_env(:ex_cldr, :cacertfile)\n\n# Populated if hex package `CAStore` is configured\nCAStore.file_path()\n\n# Populated if hex package `certfi` is configured\n:certifi.cacertfile()\n\n# Debian/Ubuntu/Gentoo etc.\n\"/etc/ssl/certs/ca-certificates.crt\",\n\n# Fedora/RHEL 6\n\"/etc/pki/tls/certs/ca-bundle.crt\",\n\n# OpenSUSE\n\"/etc/ssl/ca-bundle.pem\",\n\n# OpenELEC\n\"/etc/pki/tls/cacert.pem\",\n\n# CentOS/RHEL 7\n\"/etc/pki/ca-trust/extracted/pem/tls-ca-bundle.pem\",\n\n# Open SSL on MacOS\n\"/usr/local/etc/openssl/cert.pem\",\n\n# MacOS & Alpine Linux\n\"/etc/ssl/cert.pem\"\n```","ref":"TzWorld.Downloader.html#get_with_headers/2-certificate-stores"},{"type":"function","title":"TzWorld.Downloader.latest_release/2","doc":"Return the `{release_number, download_url}` of\nthe latest timezones geo JSON data","ref":"TzWorld.Downloader.html#latest_release/2"},{"type":"function","title":"TzWorld.Downloader.otp_version/0","doc":"","ref":"TzWorld.Downloader.html#otp_version/0"},{"type":"function","title":"TzWorld.Downloader.update_release/1","doc":"Updates the timezone geo JSON data if there\nis a more recent release.","ref":"TzWorld.Downloader.html#update_release/1"},{"type":"function","title":"Arguments - TzWorld.Downloader.update_release/1","doc":"* `options` is a keyword list of options. The\n  default is `[include_oceans: false, force: false]`.","ref":"TzWorld.Downloader.html#update_release/1-arguments"},{"type":"function","title":"Options - TzWorld.Downloader.update_release/1","doc":"* `:include_oceans` is a boolean that indicates whether\n  to include time zone data for the world's oceans. The\n  default is `false`.\n\n* `:force` is a boolean that indicates whether to force\n  an update of the data, even if the current data is the\n  latest release.  This option is useful when switching\n  from the data without oceans to the data with oceans\n  (or the other way arouond).","ref":"TzWorld.Downloader.html#update_release/1-options"},{"type":"function","title":"TzWorld.Downloader.update_release/3","doc":"","ref":"TzWorld.Downloader.html#update_release/3"},{"type":"extras","title":"TzWorld","doc":"# TzWorld\n\n[![hex.pm](https://img.shields.io/hexpm/v/tz_world.svg)](https://hex.pm/packages/tz_world)\n[![hex.pm](https://img.shields.io/hexpm/dt/tz_world.svg)](https://hex.pm/packages/tz_world)\n[![hex.pm](https://img.shields.io/hexpm/l/tz_world.svg)](https://hex.pm/packages/tz_world)\n[![github.com](https://img.shields.io/github/last-commit/kimlai/tz_world.svg)](https://github.com/kimlai/tz_world)\n\nResolve timezones from a location using data from the\n[timezone-boundary-builder](https://github.com/evansiroky/timezone-boundary-builder)\nproject.","ref":"readme.html"},{"type":"extras","title":"Installation - TzWorld","doc":"Add `tz_world` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:tz_world, \"~> 1.3\"}\n  ]\nend\n```\n\nAfter adding `TzWorld` as a dependency, run `mix deps.get` to install it. Then run `mix tz_world.update` to install the timezone data.\n\n**NOTE** No data is installed with the package and until the data is installed\nwith `mix tz_world.update` all calls to `TzWorld.timezone_at/1` will return\n`{:error, :time_zone_not_found}`.","ref":"readme.html#installation"},{"type":"extras","title":"Configuration - TzWorld","doc":"There is no mandatory configuration required however four options may be configured in `config.exs`:\n\n```elixir\nconfig :tz_world,\n  # Configure a custom TzWorld backend. It will be used\n  # as the default backend in calls to `TzWorld.timezone_at/1`\n  backend: MyTzWorldBackend,\n  # The default is the `priv` directory of `:tz_world`\n  data_dir: \"geodata/directory\",\n  # The default is either the trust store included in the\n  # libraries `CAStore` or `certifi` or the platform\n  # trust store.\n  cacertfile: \"path/to/ca_trust_store\",\n  # The default is no options, however one can set any `httpc` client options.\n  httpc_opts: [\n    proxy: {{String.to_charlist(proxy_host), proxy_port}, []}\n  ]\n```","ref":"readme.html#configuration"},{"type":"extras","title":"Backend selection - TzWorld","doc":"`TzWorld` provides alternative strategies for managing access to the backend data. Each backend is implemented as a `GenServer` that needs to be either manually started with `BackendModule.start_link/1` or preferably added to your application's supervision tree.\n\nThe recommended backend is `TzWorld.Backend.EtsWithIndexCache` unless the host system is memory constrained in which case `TzWorld.Backend.DetsWithIndexCache` is recommended.\n\nFor example:\n\n```elixir\ndefmodule MyApp.Application do\n  @moduledoc false\n\n  use Application\n\n  def start(_type, _args) do\n    children = [\n      ...\n      TzWorld.Backend.EtsWithIndexCache\n    ]\n\n    opts = [strategy: :one_for_one, name: MyApp.Supervisor]\n    Supervisor.start_link(children, opts)\n  end\nend\n```\nThe following backends are available:\n\n* `TzWorld.Backend.Memory` which retains all data in memory for fast (but *not*\n  fastest) performance at the expense of using approximately 1GB of memory\n\n* `TzWorld.Backend.Dets` which uses Erlang's `:dets` data store. This uses\n  negligible memory at the expense of slow access times (approximately 500ms in\n  testing)\n\n* `TzWorld.Backend.DetsWithIndexCache` which balances memory usage and\n  performance. This backend is recommended in most situations since its\n  performance is similar to `TzWorld.Backend.Memory` (about 5% slower in\n  testing) and uses about 25Mb of memory\n\n* `TzWorld.Backend.Ets` which uses `:ets` for storage. With the default\n  settings of `:compressed` for the `:ets` table its memory consumption is\n  about 512Mb  but with access that is over 20 times slower than\n  `TzWorld.Backend.DetsWithIndexCache`\n\n* `TzWorld.Backend.EtsWithIndexCache` which uses `:ets` for storage with an\n  additional in-memory cache of the bounding boxes. This still uses about 512Mb\n  but is faster than any of the other backends by about 40%\n  \nOther backends can be implemented as long as they follow the `TzWorld.Backend`\nbehaviour. Custom backends should be configured in `config.exs` or `runtime.exs`\nunder the `:backend` key so that it will be considered as the default for calls\nto `TzWorld.timezone_at/1`. For example:\n\n```elixir\nconfig :tz_world,\n  backend: MyTzWorldBackend\n```","ref":"readme.html#backend-selection"},{"type":"extras","title":"Installing the Timezones Geo JSON data - TzWorld","doc":"Installing `tz_world` from source or from hex does not include the timezones\nGeo JSON data. The data is required and to install or update it run:\n\n```elixir\nmix tz_world.update\n```\n\nThis task will download, transform, zip and store the timezones Geo data. Depending on internet and computer speed this may take a few minutes.\n\nBy default `mix tz_world.update` will download geojson data that does *not* include time zone information for the oceans. There are two optional parameters that are accepted by `mix tz_world.update` that can be used to configure the desired behaviour:\n\n* `--include-oceans` will download the geojson data, including data for the oceans. This give almost complete global coverage of time zone data.  The default is `--no-include-oceans` which does not include data that covers the oceans. The geojson data including the oceans is about 10% larger than the data that does not include the oceans.\n\n* `--force` will force an update to the geojson data even if the installed data is the latest release. This option can be useful if you choose to switch from the data without ocean coverage to the data with ocean coverage (and the reverse). The default is `--no-force`.","ref":"readme.html#installing-the-timezones-geo-json-data"},{"type":"extras","title":"Updating the Timezone data - TzWorld","doc":"From time-to-time the timezones Geo JSON data is updated in the [upstream project](https://github.com/evansiroky/timezone-boundary-builder/releases). The mix task `mix tz_world.update` will update the data if it is available.\n\nA running application can also be instructed to reload the data by executing `TzWorld.reload_timezone_data`.","ref":"readme.html#updating-the-timezone-data"},{"type":"extras","title":"Usage - TzWorld","doc":"The primary API is `TzWorld.timezone_at`. It takes either a `Geo.Point` struct or a `longitude` and `latitude` in degrees. Note the parameter order: `longitude`, `latitude`. It also takes and optional second parameter, `backend`, which must be one of the configured and running backend modules.  By default `timezone_at/2` will detect a running backend and will raise an exception if no running backend is found.\n\n```elixir\niex> TzWorld.timezone_at(%Geo.Point{coordinates: {3.2, 45.32}})\n{:ok, \"Europe/Paris\"}\n\niex> TzWorld.timezone_at({3.2, 45.32})\n{:ok, \"Europe/Paris\"}\n\niex> TzWorld.timezone_at(%Geo.PointZ{coordinates: {-74.006, 40.7128, 0.0}})\n{:ok, \"America/New_York\"}\n\n# Assumes that the downloaded data does not include\n# data for the oceans (the default)\niex> TzWorld.timezone_at(%Geo.Point{coordinates: {1.3, 65.62}})\n{:error, :time_zone_not_found}\n```","ref":"readme.html#usage"},{"type":"extras","title":"LICENSE","doc":"MIT License\n\nCopyright (c) 2017 kimlai\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.","ref":"license.html"},{"type":"extras","title":"CHANGELOG","doc":"","ref":"changelog.html"},{"type":"extras","title":"Changelog for Tz_World - CHANGELOG","doc":"","ref":"changelog.html#changelog-for-tz_world"},{"type":"extras","title":"Tz_World v1.4.0 - CHANGELOG","doc":"This is the changelog for Tz_World v1.4.0 released on September 29th, 2024.  For older changelogs please consult the release tag on [GitHub](https://github.com/kimlai/tz_world/tags)","ref":"changelog.html#tz_world-v1-4-0"},{"type":"extras","title":"Enhancements - CHANGELOG","doc":"* Adds support for easier configuration of default custom backends.  In previous releases, the default backend was resolved by only considering the built-in backends. From this release, a custom backend can be configured in `config.exs` or `runtime.exs`. If so configured, that backend will be the default for calls to `TzWorld.timezone_at/1`. For example:\n\n```elixir\nconfig :tz_world,\n  default_backend: MyTzWorldBackend\n```\n\n* Adds a `--trace` flag to `mix tz_world.update`. This flag will trigger additional logging during the update process including memory utilization on the BEAM.\n\n* Adds some memory use optimizations during the download process. Relates to #38 but likely does not fully solve this issue.\n \n* Add support for [geo 4.0](https://github.com/felt/geo).","ref":"changelog.html#enhancements"},{"type":"extras","title":"Tz_World v1.3.3 - CHANGELOG","doc":"This is the changelog for Tz_World v1.3.3 released on May 27th, 2024.  For older changelogs please consult the release tag on [GitHub](https://github.com/kimlai/tz_world/tags)","ref":"changelog.html#tz_world-v1-3-3"},{"type":"extras","title":"Bug Fixes - CHANGELOG","doc":"* Fixes compiler warnings for Elixir 1.17.","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Tz_World v1.3.2 - CHANGELOG","doc":"This is the changelog for Tz_World v1.3.2 released on December 2nd 2023.  For older changelogs please consult the release tag on [GitHub](https://github.com/kimlai/tz_world/tags)","ref":"changelog.html#tz_world-v1-3-2"},{"type":"extras","title":"Bug Fixes - CHANGELOG","doc":"* Fixes compiler warnings for Elixir 1.16.","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Tz_World v1.3.1 - CHANGELOG","doc":"This is the changelog for Tz_World v1.3.1 released on August 17th, 2023.  For older changelogs please consult the release tag on [GitHub](https://github.com/kimlai/tz_world/tags)","ref":"changelog.html#tz_world-v1-3-1"},{"type":"extras","title":"Bug Fixes - CHANGELOG","doc":"Thanks to @mjquinlan2000 for the report of issues on Elixir 1.15 and OTP 26.\n\n* Always send a `User-Agent` header to the Github API to avoid 403 responses.\n\n* Add `:ssl` to `:extra_applications` to support Elixir 1.15 and OTP 26.\n\n* Update `TzWorld.Downloader.get_url/1` to follow the [erlef security guidelines](https://erlef.github.io/security-wg/secure_coding_and_deployment_hardening/ssl).","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Tz_World v1.3.0 - CHANGELOG","doc":"This is the changelog for Tz_World v1.3.0 released on April 5th, 2023.  For older changelogs please consult the release tag on [GitHub](https://github.com/kimlai/tz_world/tags)","ref":"changelog.html#tz_world-v1-3-0"},{"type":"extras","title":"Enhancements - CHANGELOG","doc":"* Add httpc [set_options/1](https://www.erlang.org/doc/man/httpc.html#set_options-1) support. Thanks to @gabrielgiordan for the PR (and the PR for fixing CI).","ref":"changelog.html#enhancements"},{"type":"extras","title":"Tz_World v1.2.0 - CHANGELOG","doc":"This is the changelog for Tz_World v1.2.0 released on October 12th, 2022.  For older changelogs please consult the release tag on [GitHub](https://github.com/kimlai/tz_world/tags)","ref":"changelog.html#tz_world-v1-2-0"},{"type":"extras","title":"Bug Fixes - CHANGELOG","doc":"* Fix `TzWorld.Backend.Dets` to not raise an exception if there is no timezone data available.","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Enhancements - CHANGELOG","doc":"* Adds options to `mix tzworld.update` mix task:\n  * `--include_oceans` will download a 10% larger geojson data set that covers the worlds oceans\n  * `--force` will force a data update, even if the data is the latest release. This can be used\n    to switch between data that includes oceans and that which does not.\n  * Thanks to @lguminski for the feedback and suggestion.","ref":"changelog.html#enhancements"},{"type":"extras","title":"Tz_World v1.1.0 - CHANGELOG","doc":"This is the changelog for Tz_World v1.1.0 released on August 26th, 2022.  For older changelogs please consult the release tag on [GitHub](https://github.com/kimlai/tz_world/tags)","ref":"changelog.html#tz_world-v1-1-0"},{"type":"extras","title":"Enhancements - CHANGELOG","doc":"* Replace `Application.get_env/2` with `Application.compile_env/2` to remove warnings on Elixir 1.14. Now requires Elixir 1.10 as a minimum version.","ref":"changelog.html#enhancements"},{"type":"extras","title":"Tz_World v1.0.0 - CHANGELOG","doc":"This is the changelog for Tz_World v1.0.0 released on October 19th, 2021.  For older changelogs please consult the release tag on [GitHub](https://github.com/kimlai/tz_world/tags)","ref":"changelog.html#tz_world-v1-0-0"},{"type":"extras","title":"Enhancements - CHANGELOG","doc":"* Update to version 1.0.0 since the API has been stable for a year.","ref":"changelog.html#enhancements"},{"type":"extras","title":"Tz_World v0.7.1 - CHANGELOG","doc":"This is the changelog for Tz_World v0.7.1 released on November 6th, 2020.  For older changelogs please consult the release tag on [GitHub](https://github.com/kimlai/tz_world/tags)","ref":"changelog.html#tz_world-v0-7-1"},{"type":"extras","title":"Bug Fixes - CHANGELOG","doc":"* Don't use tests for the external data version since that changes outside of the code lifesycle","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Tz_World v0.7.0 - CHANGELOG","doc":"This is the changelog for Tz_World v0.7.0 released on October 10th, 2020.  For older changelogs please consult the release tag on [GitHub](https://github.com/kimlai/tz_world/tags)","ref":"changelog.html#tz_world-v0-7-0"},{"type":"extras","title":"Bug Fixes - CHANGELOG","doc":"* Add `:inets` and `:public_key` to `:extra_applications` in `mix.exs` to make Elixir 1.11 happy.","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Tz_World v0.6.0 - CHANGELOG","doc":"This is the changelog for Tz_World v0.6.0 released on June 10th, 2020.  For older changelogs please consult the release tag on [GitHub](https://github.com/kimlai/tz_world/tags)","ref":"changelog.html#tz_world-v0-6-0"},{"type":"extras","title":"Bug Fixes - CHANGELOG","doc":"* Honour the configuration for `:data_dir`. Thanks to @superhawk610. Fixes #12\n\n* Be more resilient if the `:dets` file is not in place","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Tz_World v0.5.0 - CHANGELOG","doc":"This is the changelog for Tz_World v0.5.0 released on May 23rd, 2020.  For older changelogs please consult the release tag on [GitHub](https://github.com/kimlai/tz_world/tags)","ref":"changelog.html#tz_world-v0-5-0"},{"type":"extras","title":"Bug Fixes - CHANGELOG","doc":"* Move compile time configuration of the data directory to runtime and remove hard-coded default path\n\n* Start `:inets` and `:ssl` applications in the downloader mix task\n\n* Add certificate verification when downloading updates to the geo data","ref":"changelog.html#bug-fixes"},{"type":"extras","title":"Enhancements - CHANGELOG","doc":"* Document the `:data_dir` and `:cacertfile` configuration options it the README.md file\n\n* The backends `:dets` and `:dets_with_index_cache` now open the `:dets` file as `access: :read` which prevents errors if the file is abnormally closed.","ref":"changelog.html#enhancements"},{"type":"extras","title":"Tz_World v0.4.0 - CHANGELOG","doc":"This is the changelog for Tz_World v0.4.0 released on May 12th, 2020.  For older changelogs please consult the release tag on [GitHub](https://github.com/kimlai/tz_world/tags)\n\n* Adds configurable backends. Each backend is a GenServer that must be added to an applications supervision tree or started manually.","ref":"changelog.html#tz_world-v0-4-0"},{"type":"extras","title":"Breaking change - CHANGELOG","doc":"* When specifying a `lng`, `lat` to `TzWorld.timezone_at/2` the coordinates must be wrapped in a tuple. For example `TzWorld.timezone_at({3.2, 45.32})` making it consistent with the `Geo.Point` and `Geo.PointZ` strategies.","ref":"changelog.html#breaking-change"},{"type":"extras","title":"Configurable backends - CHANGELOG","doc":"* `TzWorld.Backend.Memory` which retains all data in memory for fast (but *not* fastest) performance at the expense of using approximately 1Gb of memory\n* `TzWorld.Backend.Dets` which uses Erlang's `:dets` data store. This uses negligible memory at the expense of slow access times (approximaltey 500ms in testing)\n* `TzWorld.Backend.DetsWithIndexCache` which balances memory usage and performance. This backend is recommended in most situations since its performance is similar to `TzWorld.Backend.Memory` (about 5% slower in testing) and uses about 25Mb of memory\n* `TzWorld.Backend.Ets` which uses `:ets` for storage. With the default settings of `:compressed` for the `:ets` table its memory consumption is about 512Mb but with access that is over 20 times slower than `TzWorld.Backend.DetsWithIndexCache`\n* `TzWorld.Backend.EtsWithIndexCache` which uses `:ets` for storage with an additional in-memory cache of the bounding boxes. This still uses about 512Mb but is faster than any of the other backends by about 40%","ref":"changelog.html#configurable-backends"},{"type":"extras","title":"Enhancements - CHANGELOG","doc":"* Add `TzWorld.all_timezones_at/2` to return all timezones for a given location.  In rare cases, usually disputed territory, multiple timezones may be declared for overlapping regions. `TzWorld.all_timezones_at/2` returns a (potentially empty) list of all time zones known for a given point.  *Futher testing of this function is required and will be completed before version 1.0*.","ref":"changelog.html#enhancements"},{"type":"extras","title":"Tz_World v0.3.0 - CHANGELOG","doc":"This is the changelog for Tz_World v0.3.0 released on December 4th, 2019.  For older changelogs please consult the release tag on [GitHub](https://github.com/kimlai/tz_world/tags)","ref":"changelog.html#tz_world-v0-3-0"},{"type":"extras","title":"Breaking Changes - CHANGELOG","doc":"* Changes the error return from `{:error, :timezone_not_found}` to `{:error, :time_zone_not_found}` since both Elixir and Tzdata use `time_zone`.","ref":"changelog.html#breaking-changes"},{"type":"extras","title":"Enhancements - CHANGELOG","doc":"* Allows both `%Geo.Point{}` and `%Geo.PointZ{}` as parameters to `TzWorld.timezone_at/1`","ref":"changelog.html#enhancements"},{"type":"extras","title":"Tz_World v0.2.0 - CHANGELOG","doc":"This is the changelog for Tz_World v0.2.0 released on November 28th, 2019.  For older changelogs please consult the release tag on [GitHub](https://github.com/kimlai/tz_world/tags)","ref":"changelog.html#tz_world-v0-2-0"},{"type":"extras","title":"Breaking Changes - CHANGELOG","doc":"* Requires OTP 21 and Elixir 1.6 or later due to the use of GenServer's `handle_continue/2`\n\n* `timezone_at/1` returns tagged tuples `{:ok, result}` or `{:error, reason}`. There can be at least two reasons for an error: no data file is available or no timezone is found. These return `{:error, :enoent}` and `{:error, :timezone_not_found}` respectively\n\n* The timezone geojson data is no longer included in the package. Run `mix tz_world.update` to install or update it.\n\n* No longer uses Ecto or PostGIS for calculations.","ref":"changelog.html#breaking-changes"},{"type":"extras","title":"Enhancements - CHANGELOG","doc":"* Updated to latest shape data. Takes the geo JSON shape data directly from [timezone-boundary-builder releases](https://github.com/evansiroky/timezone-boundary-builder/releases)\n\n* Conforms TzWorker to the modern `child_spec/1` including using `handle_continue/2` to load the data file if it exists.\n\n* Updated dependencies including [geo](https://hex.pm/packages/geo) to allow `1.x`, `2.x` or `3.x`\n\n* Added `Jason` as an optional dependency to facilitate decoding the GeoJSON from `timezone_boundary_builder`\n\n* The timezone geojson data is no longer included in the package. Its size isn't supported on hex and it bloats the repo too. A mix task `tz_world.update` downloads and processes the data. The function `TzWorld.Downloader.update_release/0` can be called at any time to look for a new release, download it and load it into the running server with no downtime.\n\n* `timezone_at/1` supports simple `lng`, `lat` arguments as well as `%Geo.Point{}` structs\n\n* Added `CHANGELOG.md`\n\n* Added SRID to the GeoJSON\n\n* Updated package and ran dialyzer\n\n* Added a config option :data_dir specifies the location of the compressed etf. Default is `./priv`\n\n* Updated README, package and docs","ref":"changelog.html#enhancements"}],"content_type":"text/markdown","producer":{"name":"ex_doc","version":[48,46,51,52,46,50]}}